package Level2;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Jul 18, 2004
 * Time: 1:47:00 PM
 * To change this template use File | Settings | File Templates.
 */
public class GroupInfo {
    private  ArrayList clientServers = new ArrayList();
    private  ArrayList users = new ArrayList();
    private  String urlDisplay = null;
    private  String  groupName = null;


    public GroupInfo (String name)
    {
        this.groupName = name;
    }


    public String getUrl()
    {
        return urlDisplay;
    }

    public ArrayList getUsers()
    {
        return users;
    }

    public boolean isGroupEmpty()
    {
        if (users.isEmpty())
            return true;

        return false;
    }

    public void addUser(User user)
    {
        if (users.contains(user))
           users.remove(user);


        String clientServer = user.getClientServerUrl();
        if (clientServer != null)
        {
            users.add(user);
            if (!containsClientServer(clientServer))
                addClientServer(clientServer);
        }

        System.out.print("Add User: Lists are:");
        printInfo();
    }

    public  void removeUser(User user)
    {
        String clientServer = user.getClientServerUrl();
        if (clientServer != null)
        {
            users.remove(user);
            if (!clientServerHasActiveUsers(clientServer))
                removeClientServer(clientServer);
        }

        System.out.print("Remove User: Lists are:");
        printInfo();
    }

    public void printInfo()
    {
        System.out.println("groupName is :" + groupName);
        System.out.println("displayUrl: " + urlDisplay);
        System.out.println("clientServers : ");
        for (Iterator itr = clientServers.iterator(); itr.hasNext();)
            System.out.println((String)itr.next());

        System.out.println("users : ");
        for (Iterator itr = users.iterator(); itr.hasNext();)
                System.out.println((User)itr.next());
    }

    public void updateUrlForGroup(String url)
    {
        urlDisplay = url;
    }

    public void addClientServer(String url)
    {
        if (!clientServers.contains("url"))
            clientServers.add(url);
    }

    public void removeClientServer(String url)
    {
        clientServers.remove(url);
    }

    public boolean containsClientServer(String url)
    {
        if (clientServers.contains(url))
            return true;

        return false;
    }

    public boolean clientServerHasActiveUsers(String url)
    {
        for (Iterator itr = users.iterator(); itr.hasNext();)
        {
            User user = (User)itr.next();
            if (user.getClientServerUrl().equals(url))
                return true;
        }

        return false;
    }

    public ArrayList getClientServers()
    {
        return clientServers;
    }
}
