
/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Mar 7, 2004
 * Time: 5:51:20 PM
 * To change this template use File | Settings | File Templates.
 */
// Copyright (c) 2000 Just Objects B.V. <just@justobjects.nl>
// Distributable under LGPL license. See terms of license at gnu.org.





import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Date;
import java.sql.Time;
import java.sql.Timestamp;

/**
 * Servlet to post an Event from a client to the Publisher.
 *
 * @version $Id: Postlet.java,v 1.2 2003/08/15 08:37:40 justb Exp $
 * @author Just van den Broecke - Just Objects &copy;
 */
public class Postlet extends HttpServlet {

        /** Servlet GET request: extracts event data and publishes to Publisher. */
        public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {


                String subject = request.getParameter("subject");

                if (subject == null || subject.equals("")) {
                        return;
                }

                String  serverLogin = request.getParameter("serverLogin");
                String serverId = request.getParameter("serverId");
                String groupId = request.getParameter("groupID");


                if (serverLogin==null || serverLogin.equals("") || serverId==null
                      || serverId.equals("") || groupId==null || groupId.equals(""))
                        return;


                // Create evcent and set attributes from parameters
                Event event = new Event(subject);

                for (Enumeration e = request.getParameterNames(); e.hasMoreElements();) {
                        String nextAttribute = (String) e.nextElement();
                        event.setAttribute(nextAttribute, request.getParameter(nextAttribute));
                }

                String receivedEvent = event.getAttribute("event");
                if (receivedEvent.equals("chat"))
                {

                    long time = System.currentTimeMillis();
                    System.out.println("received chat : " + time);
                    event.setAttribute("value", serverLogin+serverId+"::"+event.getAttribute("value"));
                }




                //!!!!!!!!!!!!Need to change to send to backend server instead !!!!!!!!!


                //Publisher.getInstance().publish(event);

                String level2Url = Publisher.getInstance().getGroupLevel2Url(event.getAttribute("groupID"));
                if (level2Url==null)
                {
                    throw new IOException("Unable to find Level2 server Url");
                }

                new sendToLevel2(level2Url, event.getAttribute("groupID"), "sanluis.uccs.edu:8289", event.toXML());
                response.setStatus(HttpServletResponse.SC_NO_CONTENT);

        }

        // TODO: Allow POSTing of Events as XML or Serialized Objects

}

/*
 * $Log: Postlet.java,v $
 * Revision 1.2  2003/08/15 08:37:40  justb
 * fix/add Copyright+LGPL file headers and footers
 *
 * Revision 1.1  2003/08/13 13:26:57  justb
 * moved all servlets to servlet package
 *
 * Revision 1.2  2003/05/18 16:15:08  justb
 * support for XML encoded Events
 *
 * Revision 1.1.1.1  2002/09/24 21:02:31  justb
 * import to sourceforge
 *
 * Revision 1.1.1.1  2002/09/20 22:48:18  justb
 * import to SF
 *
 * Revision 1.1.1.1  2002/09/20 14:19:03  justb
 * first import into SF
 *
 * Revision 1.3  2002/04/15 20:42:41  just
 * reformatting and renaming GuardedQueue to BlockingQueue
 *
 * Revision 1.2  2000/08/21 20:48:29  just
 * added CVS log and id tags plus copyrights
 *
 *
 */

