
/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Mar 7, 2004
 * Time: 5:40:14 PM
 * To change this template use File | Settings | File Templates.
 */
// Copyright (c) 2000 Just Objects B.V. <just@justobjects.nl>
// Distributable under LGPL license. See terms of license at gnu.org.



import java.util.*;
import java.net.URL;
import java.net.URLConnection;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Dispatcher of Events to Subscribers.
 *
 * @version $Id: Publisher.java,v 1.4 2003/08/15 08:37:40 justb Exp $
 * @author Just van den Broecke - Just Objects &copy;
 **/
public class Publisher {
        private Hashtable groups = new Hashtable();
        private Hashtable level2Url = new Hashtable();
        private ArrayList subscribers = null;
        private boolean eventSourceManagerActiveted = false;
        private static final Publisher instance = new Publisher();
        private static int numActiveUsers = 0;
        private static final int highUsage = 8;
        private static final int lowUsage = 2;
        private static final int mediumUsage = 5;
        private static int currentUsage = lowUsage;
        private static final String level1Url = "sanluis.uccs.edu:8289";
        private static final String balancerUrl = "wetterhorn.uccs.edu:8288";

        private Publisher() {
        }

        public  void printgroups()
        {
            Enumeration keys = groups.keys();
            System.out.println("Groups:");
            while (keys.hasMoreElements())
            {
                List subscribers = (List)groups.get(keys.nextElement());

                for (Iterator itr = subscribers.iterator(); itr.hasNext();)
                {
                    Subscriber subr = (Subscriber)itr.next();
                    System.out.println("name, id, group : " + subr.getServerLogin() + " " + subr.getServerId() + " " + subr.getGroup());
                }

            }
        }

        public  void printlevel2Url()
        {
            System.out.println("LEVEL 2 URL!!!!");
            Enumeration keys = level2Url.keys();
            while (keys.hasMoreElements())
            {
                String group =  (String)keys.nextElement();
                System.out.println("group, level2Url :" + group + (String)level2Url.get(group));

            }
        }

        public static Publisher getInstance() {
                return instance;
        }


       private void updateBalancer(String load)
       {
        try {

         URL urlConn = new URL("http://" + balancerUrl + "/CoWebBrowseProj/updateLoadInfo");
         URLConnection connection = urlConn.openConnection();
         connection.setDoOutput(true);
         connection.setDoInput(true);

         PrintWriter out = new PrintWriter(
                              connection.getOutputStream());

         out.write("url=" + level1Url + "&usageLoad=" + load);
         out.flush();
         out.close();

         BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                connection.getInputStream()));
        String inputLine;

        while ((inputLine = in.readLine()) != null)
            System.out.println(inputLine);


	    in.close();
       }
       catch (Exception e)
       {
           System.out.println("Unable to send usage info to load balancer");
           e.printStackTrace();
       }
    }


       public synchronized void addActiveUser()
       {
           numActiveUsers++;

           switch (currentUsage)
           {
               case highUsage:
                  if (numActiveUsers<=mediumUsage && numActiveUsers >lowUsage)
                  {
                    currentUsage = mediumUsage;
                    updateBalancer("MEDIUM");
                  }
                  else
                  {
                     if (numActiveUsers<= lowUsage)
                     {
                        currentUsage = lowUsage;
                        updateBalancer("LOW");
                     }
                  }
                  break;

               case mediumUsage:
                  {
                     if (numActiveUsers<=lowUsage)
                     {
                         currentUsage = lowUsage;
                         updateBalancer("LOW");
                     }
                     else
                    {
                        if (numActiveUsers > mediumUsage)
                        {
                            currentUsage = highUsage;
                            updateBalancer("HIGH");
                        }
                    }
                   }
                   break;

               case lowUsage:
                   {
                     if (numActiveUsers>lowUsage && numActiveUsers <= mediumUsage)
                     {
                         currentUsage = mediumUsage;
                         updateBalancer("MEDIUM");
                     }
                     else
                    {
                        if (numActiveUsers > mediumUsage)
                        {
                            currentUsage = highUsage;
                            updateBalancer("HIGH");
                        }
                    }
                   }
                   break;
               default: System.out.println("Issue with Load Balancing Algorithm");
           }

       }

       public synchronized void removeActiveUser()
       {
          numActiveUsers--;


          switch (currentUsage)
           {
               case highUsage:
                  if (numActiveUsers<=mediumUsage && numActiveUsers >lowUsage)
                  {
                    currentUsage = mediumUsage;
                    updateBalancer("MEDIUM");
                  }
                  else
                  {
                     if (numActiveUsers<= lowUsage)
                     {
                        currentUsage = lowUsage;
                        updateBalancer("LOW");
                     }
                  }
                  break;

               case mediumUsage:
                  {
                     if (numActiveUsers<=lowUsage)
                     {
                         currentUsage = lowUsage;
                         updateBalancer("LOW");
                     }
                     else
                    {
                        if (numActiveUsers > mediumUsage)
                        {
                            currentUsage = highUsage;
                            updateBalancer("HIGH");
                        }
                    }
                   }
                   break;

               case lowUsage:
                   {
                     if (numActiveUsers>lowUsage && numActiveUsers <= mediumUsage)
                     {
                         currentUsage = mediumUsage;
                         updateBalancer("MEDIUM");
                     }
                     else
                    {
                        if (numActiveUsers > mediumUsage)
                        {
                            currentUsage = highUsage;
                            updateBalancer("HIGH");
                        }
                    }
                   }
                   break;
               default: System.out.println("Issue with Load Balancing Algorithm");
           }
       }



       public String getGroupLevel2Url(String groupId)
       {
          if (level2Url.containsKey(groupId))
          {
              return ((String)level2Url.get(groupId));
          }
          else
              return null;
       }

        /** Add subscriber. */
        synchronized public Event join(Subscriber subscriber)
        {
                Event aStatusEvent = null;
                if (groups.containsKey(subscriber.getGroup()))
                {
                   subscribers = (ArrayList)groups.get(subscriber.getGroup());

                }
                else
                {

                   subscribers =  new ArrayList();
                   groups.put(subscriber.getGroup(), subscribers);

                }

                if (level2Url.containsKey(subscriber.getGroup()))
               {
                   level2Url.remove(subscriber.getGroup());
               }

               level2Url.put(subscriber.getGroup(), subscriber.getLevel2Url());

                log(subscriber.getAddress() + " joined subject " + subscriber.getSubject());

                // Activate event generators on first subscriber
                if (!eventSourceManagerActiveted) {

                      EventSourceManager.activate();
                      eventSourceManagerActiveted = true;
                }

                Event confirmLoginevent = new Event("CoBrowsePushlet");
                confirmLoginevent.setAttribute("event", "login");
                confirmLoginevent.setAttribute("serverLogin", subscriber.getServerLogin());
                confirmLoginevent.setAttribute("serverId", subscriber.getServerId());
                confirmLoginevent.setAttribute("groupID", subscriber.getGroup());
                try
                {
                    subscriber.getClientAdapter().push(confirmLoginevent);
                }
                catch (Exception e)
                {
                    e.printStackTrace();
                    //TODO need to figure this out
                }

                subscribers.add(subscriber);
                aStatusEvent = new Event("CoBrowsePushlet");
                aStatusEvent.setAttribute("event", "status");
                aStatusEvent.setAttribute("name", subscriber.getServerLogin() );
                aStatusEvent.setAttribute("id", subscriber.getServerId() );
                aStatusEvent.setAttribute("value", "add");
                aStatusEvent.setAttribute("groupID", subscriber.getGroup());
                addActiveUser();
                //System.out.println("JOIN");
                //this.printgroups();
                //this.printlevel2Url();

                return aStatusEvent;
                

        }


        /** Publish event to subscribers matching topic. */
        synchronized public void publish(Event event) {
                // Remove subscribers registered for removal.

                String group = event.getAttribute("groupID");
                //System.out.println("about to publish to group : " + group);

                if (groups.get(group)==null)
                    return;
                subscribers = (ArrayList)groups.get(group);

                int size = subscribers.size();


                Subscriber nextSubscriber = null;
                String subject = event.getSubject();
               
                for (Iterator itr = subscribers.iterator(); itr.hasNext();) {
                        nextSubscriber =  (Subscriber)itr.next();

                        // Send only if the subscriber's criteria
                        // match the event or if probing the client.
                       // System.out.print("Subscriber to publish: " + nextSubscriber.getAddress());
                        if (nextSubscriber.match(event) || subject.equals("probe")) {

                                nextSubscriber.send((Event) event.clone());

                        }

                }


        }

        /** Remove possible subscribers registered for removal. */
        synchronized public void leave(Subscriber subscriber) {


                //System.out.println("Inside leave");
                List subscribersForGroup = (List)groups.get(subscriber.getGroup());
                if (subscribersForGroup != null)
                {

                    subscribersForGroup.remove(subscriber);

                    if (subscribersForGroup.size()== 0)
                    {

                        if (groups!=null)
                        {
                            groups.remove(subscriber.getGroup());
                            level2Url.remove(subscriber.getGroup());
                        }
                    }

                    removeActiveUser();
                }
                //System.out.println("LEAVE");
                //this.printgroups();
                //this.printlevel2Url();
        }

        /** Util: stdout printing. */
        private void log(String s) {
                Log.info("Publisher: " + new Date() + " " + s);
        }
}

/*
 * $Log: Publisher.java,v $
 * Revision 1.4  2003/08/15 08:37:40  justb
 * fix/add Copyright+LGPL file headers and footers
 *
 * Revision 1.3  2003/08/12 08:54:40  justb
 * added getSubscriberCount() and use Log
 *
 * Revision 1.2  2003/05/18 16:15:08  justb
 * support for XML encoded Events
 *
 * Revision 1.1.1.1  2002/09/24 21:02:31  justb
 * import to sourceforge
 *
 * Revision 1.1.1.1  2002/09/20 22:48:18  justb
 * import to SF
 *
 * Revision 1.1.1.1  2002/09/20 14:19:04  justb
 * first import into SF
 *
 * Revision 1.3  2002/04/15 20:42:41  just
 * reformatting and renaming GuardedQueue to BlockingQueue
 *
 * Revision 1.2  2000/08/21 20:48:29  just
 * added CVS log and id tags plus copyrights
 *
 *
 */
