
/**
 * Created by IntelliJ IDEA.
 * User: Patricia
 * Date: Mar 7, 2004
 * Time: 5:42:08 PM
 * To change this template use File | Settings | File Templates.
 */
// Copyright (c) 2000 Just Objects B.V. <just@justobjects.nl>
// Distributable under LGPL license. See terms of license at gnu.org.


import org.jdom.input.SAXBuilder;
import org.jdom.Document;
import org.jdom.Element;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.List;
import java.util.Iterator;

/**
 * Gets events from queue and pushes them on a permanent HTTP connection.
 *
 * @version $Id: PushletSubscriber.java,v 1.4 2003/08/15 08:37:40 justb Exp $
 * @author Just van den Broecke - Just Objects &copy;
 **/
public class PushletSubscriber extends HTTPSubscriber {
        public PushletSubscriber() {
        }

        /** Create client notifier based on "format" parameter passed in request. */
        protected ClientAdapter createClientAdapter(HttpServletRequest httpServletRequest,
                                                                                                HttpServletResponse httpServletResponse) throws IOException {

         // Assumed to be set by parent.
        String outputFormat = getFormat();

                // Determine client adapter to create.
                if (outputFormat.equals(FORMAT_JAVASCRIPT)) {
                        // Client expects to receive Events as JavaScript dispatch calls..
                        return BrowserClientAdapter.createPushletAdapter(httpServletRequest, httpServletResponse);
                }
                else if (outputFormat.equals(FORMAT_SERIALIZED_JAVA_OBJECT)) {
                        // Client expects to receive Events as Serialized Java Objects.
                        return new JavaPushletAdapter();
                }
                else if (outputFormat.equals(FORMAT_XML)) {
                        // Client expects to receive Events as XML.
                        return new XMLPushletAdapter();
                }
                else {
                        return null;
                }
        }

       public boolean matchSubscriber (Event event)
       {


           if (!event.getAttribute("event").equals("logOff"))
               return false;


           if (this.getGroup().equals(event.getAttribute("groupID")) && this.getServerLogin().equals(event.getAttribute("serverLogin"))
             && this.getServerId().equals(event.getAttribute("serverId")))
           {
                //System.out.println("Matched Subscriber for logoff: name, id, group : " + this.getServerLogin() + " " + this.getServerId() + " " + this.getGroup());
                return true;
           }

           return false;

       }

        /** Get events from queue and push to clients. */
        public void processEvents() throws IOException {


                Event nextEvent = null;

                // Main loop: each time a event is received from the Publisher it is written to document.
                while (true) {
                        // Get next event; blocks (wait()) until event is returned
                        try {

                                nextEvent = (Event) eventQueue.deQueue();
                        } catch (InterruptedException ie) {
                                System.out.println("interrupted");
                        }

                        if (nextEvent == null) {
                                System.out.println("nothing in Queue, bailing out: " + mySubject);
                                bailout();
                                return;
                        }

                        // Let clientAdapter determine how to send event
                        try {

                                System.out.println("received event : " + nextEvent.getAttribute("event"));
                                if (nextEvent.getAttribute("event").equals("logOff"))
                                {
                                    if (matchSubscriber(nextEvent))
                                    {

                                        clientAdapter.push(nextEvent);
                                        //System.out.println("Logoff leave");
                                        bailout();
                                    }
                                    else
                                    {

                                        //need to create new event
                                        //System.out.println("Removing name, id group : " + nextEvent.getAttribute("serverLogin") + " " + nextEvent.getAttribute("serverId") + " " + nextEvent.getAttribute("groupID"));
                                        Event statusRemoveEvent = new Event("CoBrowsePushlet");
                                        statusRemoveEvent.setAttribute("event", "status");
                                        statusRemoveEvent.setAttribute("name", nextEvent.getAttribute("serverLogin"));
                                        statusRemoveEvent.setAttribute("id", nextEvent.getAttribute("serverId") );
                                        statusRemoveEvent.setAttribute("value", "remove");
                                        statusRemoveEvent.setAttribute("groupID",nextEvent.getAttribute("groupID"));
                                        clientAdapter.push(statusRemoveEvent);
                                    }


                                }
                                else
                                    clientAdapter.push(nextEvent);
                        }
                        catch (IOException ioe) {
                                // Client may have closed connection.
                                System.out.println("Caught IO exception");
                                // create a logOff event and send to backend
                                Event logOffEvent = new Event("CoBrowsePushlet");
                                logOffEvent.setAttribute("event", "logOff");
                                logOffEvent.setAttribute("serverLogin", this.getServerLogin() );
                                logOffEvent.setAttribute("serverId", this.getServerId() );
                                logOffEvent.setAttribute("groupID",this.getGroup());

                                String level2Url = Publisher.getInstance().getGroupLevel2Url(nextEvent.getAttribute("groupID"));
                                if (level2Url==null)
                                {
                                    throw new IOException("Unable to find Level2 server Url");
                                }

                                new sendToLevel2(level2Url, nextEvent.getAttribute("groupID"), "sanluis.uccs.edu:8289", logOffEvent.toXML());

                                return;
                        }
                        catch (Throwable t) {
                           //System.out.println("register for leave: " + t + " subj=" + mySubject);
                                // create a logOff event and send to backend
                            Event logOffEvent = new Event("CoBrowsePushlet");
                            logOffEvent.setAttribute("event", "logOff");
                            logOffEvent.setAttribute("serverLogin", this.getServerLogin() );
                            logOffEvent.setAttribute("serverId", this.getServerId() );
                            logOffEvent.setAttribute("groupID",this.getGroup());

                            String level2Url = Publisher.getInstance().getGroupLevel2Url(nextEvent.getAttribute("groupID"));
                            if (level2Url==null)
                            {
                                throw new IOException("Unable to find Level2 server Url");
                            }

                            new sendToLevel2(level2Url, nextEvent.getAttribute("groupID"), "sanluis.uccs.edu:8289", logOffEvent.toXML());

                            return;
                        }
                }
        }

          public void doHistory() throws IOException
        {

            Document xmlHistory = null;
            try {

                URL urlConn = new URL("http://" + this.getLevel2Url() + "/CoWebBrowseProj/history");
                URLConnection connection = urlConn.openConnection();
                connection.setDoOutput(true);
                connection.setDoInput(true);

                PrintWriter out = new PrintWriter(
                        connection.getOutputStream());

                out.write("group=" + this.getGroup());
                out.flush();
                out.close();

                BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                connection.getInputStream()));

                String inputLine;
                SAXBuilder builder = new SAXBuilder(false);
                xmlHistory = builder.build(in);

                in.close();
            }
            catch (Exception e)
            {
                System.out.println("Unable to send history event to Level 2 " + this.getLevel2Url());
                e.printStackTrace();
            }

            if (xmlHistory == null)
            {
                System.out.println("Did not get History info from level2");
                return;
            }


            System.out.println("xml is: " + xmlHistory.toString());

            try {


                Element root = xmlHistory.getRootElement();
                Element displayUrlElement = root.getChild("urlDisplay");
                String displayUrl = null;
                if (displayUrlElement != null)
                    displayUrl = displayUrlElement.getText();

                if (displayUrl !=null && displayUrl.length()>0)
                {
                    Event event =   createUrlEvent(displayUrl);
                    clientAdapter.push(event);
                }

                List users = root.getChildren("user");
                for (Iterator  i = users.iterator(); i.hasNext();)
                {
                    Element user = (Element)i.next();
                    String name = user.getChild("userName").getText();
                    String id = user.getChild("id").getText();

                    if (name !=null && id!=null && name.length()>0 && id.length()>0)
                    {
                        if (!(name.equals(this.getServerLogin())&& id.equals(this.getServerId())))
                        {
                            Event event =   createAddStatusEvent(name, id);
                            clientAdapter.push(event);
                        }
                    }

                }

            }
            catch (Exception e)
            {
                e.printStackTrace();
            }

        }

        public Event createUrlEvent(String url)
        {
            Event urlEvent = new Event("CoBrowsePushlet");
            urlEvent.setAttribute("event", "url");
            urlEvent.setAttribute("value", url);
            return urlEvent;
        }

        public Event createAddStatusEvent(String name, String id)
        {
            Event statusEvent = new Event("CoBrowsePushlet");
            statusEvent.setAttribute("event", "status");
            statusEvent.setAttribute("name", name );
            statusEvent.setAttribute("id", id);
            statusEvent.setAttribute("value", "add");
            return statusEvent;
        }

        /** Exceptional print util. */
        public void warn(String s) {
                System.out.println("PushletSubscriber-" + this + ":" + s);
        }
}

/*
 * $Log: PushletSubscriber.java,v $
 * Revision 1.4  2003/08/15 08:37:40  justb
 * fix/add Copyright+LGPL file headers and footers
 *
 * Revision 1.3  2003/08/12 09:57:06  justb
 * replaced all print statements to Log.*() calls
 *
 * Revision 1.2  2003/05/18 16:15:08  justb
 * support for XML encoded Events
 *
 * Revision 1.1.1.1  2002/09/24 21:02:32  justb
 * import to sourceforge
 *
 * Revision 1.1.1.1  2002/09/20 22:48:18  justb
 * import to SF
 *
 * Revision 1.1.1.1  2002/09/20 14:19:04  justb
 * first import into SF
 *
 * Revision 1.4  2002/04/15 20:42:41  just
 * reformatting and renaming GuardedQueue to BlockingQueue
 *
 * Revision 1.3  2000/08/21 20:48:29  just
 * added CVS log and id tags plus copyrights
 *
 *
 */

